"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    SearchRequest,
    avro_parse,
    load_schema,
)


class SearchReferenceSetsRequest(SearchRequest):
    """
    This request maps to the body of `POST /referencesets/search` as JSON.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import ga4gh as ga4gh_3_1_1

        return {
            "org.ga4gh.methods.SearchReferenceSetsRequest": ga4gh_3_1_1.SearchReferenceSetsRequest,
        }

    __slots__ = [
        "accessions",
        "assemblyId",
        "md5checksums",
        "pageSize",
        "pageToken",
    ]

    def __init__(
        self,
        accessions=list,
        assemblyId=None,
        md5checksums=list,
        pageSize=None,
        pageToken=None,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_1_1.SearchReferenceSetsRequest model.

        :param accessions:
            If nonempty, return reference sets for which the accession matches
            this string. Best to give a version number (e.g.
            `GCF_000001405.26`). If only the main accession number is
            given then all records with that main accession will be
            returned, whichever version. Note that different versions
            will have different sequences.
        :type accessions: list[str]
        :param assemblyId:
            If not null, return reference sets for which the `assemblyId` matches
            this string (case-sensitive, exact match).
        :type assemblyId: None | str
        :param md5checksums:
            If nonempty, return the reference sets which match any of the given
            `md5checksum`s. See `ReferenceSet::md5checksum` for
            details.
        :type md5checksums: list[str]
        :param pageSize:
            Specifies the maximum number of results to return in a single page. If
            unspecified, a system default will be used.
        :type pageSize: None | int
        :param pageToken:
            The continuation token, which is used to page through large result
            sets. To get the next page of results, set this parameter
            to the value of `nextPageToken` from the previous
            response.
        :type pageToken: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.1.1"
